from __future__ import absolute_import
from tornado.web import RequestHandler, Application
import psutil
import os


class InformerHandler(RequestHandler):
    def get(self):
        settings = self.application.settings
        process = psutil.Process()
        queue = settings['queue']
        return self.write(dict(
            version=__version__,
            processID=os.getpid(),
            memoryUsage=process.memory_info().rss,
            queueSize=queue.qsize(),
        ))

def setup_endpoint(queue=None):
    app = Application([(r'/info', InformerHandler)], queue=queue)
    app.listen(49223)
    return app
    