from __future__ import absolute_import
from os.path import join, dirname
from setuptools import setup
import ondemand

basepath = dirname(__file__)
binpath = join(basepath, 'bin')

setup(
  name = 'ondemand',
  packages = ['ondemand'],
  version = ondemand.__version__,
  description = 'Fourier ondemand service',
  long_description = 'You can use it for do maintenance stuff',
  scripts = [join(binpath, 'fourier-ondemand')],
  install_requires=['pyaudio', 'psutil', 'tornado==5.1.1',
    'firebase_admin==3.2', 'mutagen==1.43',
    'requests>=2.18', 'cachetools==3.1.1', 'google-auth==1.19.1',
    'pyopenssl==19.0'
  ],
  author = 'Gamaliel Espinoza M.',
  author_email = 'gamaliel.espinoza@gmail.com',
  url = 'https://git.miralo.xyz/AudioValid/fourier-ondemand',
  keywords = ['image', 'icons', ''],
  classifiers = [],
)
